'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _themeable = require('./themeable');

var _themeable2 = _interopRequireDefault(_themeable);

var _createDefaultTheme = require('./createDefaultTheme');

var _createDefaultTheme2 = _interopRequireDefault(_createDefaultTheme);

var _function = require('react-pure-render/function');

var _function2 = _interopRequireDefault(_function);

var _ActionList = require('./ActionList');

var _ActionList2 = _interopRequireDefault(_ActionList);

var _ActionPreview = require('./ActionPreview');

var _ActionPreview2 = _interopRequireDefault(_ActionPreview);

var _getInspectedState = require('./getInspectedState');

var _getInspectedState2 = _interopRequireDefault(_getInspectedState);

var _DiffPatcher = require('./DiffPatcher');

var _DiffPatcher2 = _interopRequireDefault(_DiffPatcher);

var _getBase16Theme = require('./getBase16Theme');

var _getBase16Theme2 = _interopRequireDefault(_getBase16Theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getCurrentActionId(props, state) {
  var lastActionId = props.stagedActionIds[props.stagedActionIds.length - 1];
  return state.selectedActionId === null ? lastActionId : state.selectedActionId;
}

function createState(props, state) {
  var supportImmutable = props.supportImmutable;
  var computedStates = props.computedStates;
  var actions = props.actionsById;

  var currentActionId = getCurrentActionId(props, state);
  var currentAction = actions[currentActionId] && actions[currentActionId].action;

  var fromState = currentActionId > 0 ? computedStates[currentActionId - 1] : null;
  var toState = computedStates[currentActionId];

  var fromInspectedState = fromState && (0, _getInspectedState2.default)(fromState.state, state.inspectedStatePath, supportImmutable);
  var toInspectedState = toState && (0, _getInspectedState2.default)(toState.state, state.inspectedStatePath, supportImmutable);
  var delta = fromState && toState && _DiffPatcher2.default.diff(fromInspectedState, toInspectedState);

  return {
    delta: delta,
    currentActionId: currentActionId,
    nextState: toState && (0, _getInspectedState2.default)(toState.state, state.inspectedStatePath, false),
    action: (0, _getInspectedState2.default)(currentAction, state.inspectedActionPath, false)
  };
}

var DevtoolsInspector = function (_Component) {
  (0, _inherits3.default)(DevtoolsInspector, _Component);

  function DevtoolsInspector(props) {
    (0, _classCallCheck3.default)(this, DevtoolsInspector);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(DevtoolsInspector).call(this, props));

    _this.shouldComponentUpdate = _function2.default;

    _this.state = {
      isWideLayout: false,
      selectedActionId: null,
      inspectedActionPath: [],
      inspectedStatePath: [],
      tab: 'Diff'
    };
    return _this;
  }

  (0, _createClass3.default)(DevtoolsInspector, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState(createState(this.props, this.state));
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.updateSizeTimeout = window.setInterval(function () {
        return _this2.updateSizeMode();
      }, 150);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.clearTimeout(this.updateSizeTimeout);
    }
  }, {
    key: 'updateSizeMode',
    value: function updateSizeMode() {
      this.setState({
        isWideLayout: this.refs.inspector.offsetWidth > 500
      });
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      if (this.props.computedStates !== nextProps.computedStates || getCurrentActionId(this.props, this.state) !== getCurrentActionId(nextProps, nextState) || this.state.inspectedStatePath !== nextState.inspectedStatePath || this.state.inspectedActionPath !== nextState.inspectedActionPath) {

        this.setState(createState(nextProps, nextState));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props;
      var theme = _props.theme;
      var actionIds = _props.stagedActionIds;
      var actions = _props.actionsById;
      var _state = this.state;
      var isWideLayout = _state.isWideLayout;
      var selectedActionId = _state.selectedActionId;
      var nextState = _state.nextState;
      var action = _state.action;
      var searchValue = _state.searchValue;
      var tab = _state.tab;
      var delta = _state.delta;

      var base16Theme = (0, _getBase16Theme2.default)(theme);
      var inspectorTheme = (0, _extends3.default)({}, (0, _createDefaultTheme2.default)(base16Theme), base16Theme ? {} : theme);
      var createTheme = (0, _themeable2.default)(inspectorTheme);
      var inspectedPathType = tab === 'Action' ? 'inspectedActionPath' : 'inspectedStatePath';

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ key: 'inspector'
        }, createTheme('inspector', isWideLayout && 'inspectorWide'), {
          ref: 'inspector' }),
        _react2.default.createElement(_ActionList2.default, (0, _extends3.default)({ actions: actions, actionIds: actionIds, isWideLayout: isWideLayout, searchValue: searchValue, selectedActionId: selectedActionId }, {
          theme: inspectorTheme,
          onSearch: function onSearch(val) {
            return _this3.setState({ searchValue: val });
          },
          onSelect: function onSelect(actionId) {
            return _this3.setState({
              selectedActionId: actionId === selectedActionId ? null : actionId
            });
          } })),
        _react2.default.createElement(_ActionPreview2.default, (0, _extends3.default)({ base16Theme: base16Theme, tab: tab, delta: delta, nextState: nextState, action: action }, {
          theme: inspectorTheme,
          onInspectPath: function onInspectPath(path) {
            return _this3.setState((0, _defineProperty3.default)({}, inspectedPathType, path));
          },
          inspectedPath: this.state[inspectedPathType],
          onSelectTab: function onSelectTab(tab) {
            return _this3.setState({ tab: tab });
          } }))
      );
    }
  }]);
  return DevtoolsInspector;
}(_react.Component);

DevtoolsInspector.propTypes = {
  dispatch: _react.PropTypes.func,
  computedStates: _react.PropTypes.array,
  stagedActionIds: _react.PropTypes.array,
  actionsById: _react.PropTypes.object,
  currentStateIndex: _react.PropTypes.number,
  monitorState: _react.PropTypes.shape({
    initialScrollTop: _react.PropTypes.number
  }),
  preserveScrollTop: _react.PropTypes.bool,
  stagedActions: _react.PropTypes.array,
  select: _react.PropTypes.func.isRequired,
  theme: _react.PropTypes.oneOfType([_react.PropTypes.object, _react.PropTypes.string]),
  supportImmutable: _react.PropTypes.bool
};

DevtoolsInspector.update = function (s) {
  return s;
};

DevtoolsInspector.defaultProps = {
  theme: {},
  select: function select(state) {
    return state;
  },
  supportImmutable: false
};
exports.default = DevtoolsInspector;